//+------------------------------------------------------------------+
//|                                                 Active Panel.mq5 |
//|              Copyright Copyright 2010, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2010, MetaQuotes Software Corp."
#property link      "http://www.mql5.com"
#property version   "1.00"
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
input bool Reset_Expert_Settings=false;//C 

double Bid,Ask;         //   
datetime time_current;  //  
int wnd=-1;             //   
bool last_loaded=false; // ,  ,  
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//---
   //     1 
   EventSetTimer(1); 
   //  
   get_prices();
   //   
   wnd=ChartWindowFind(0,"AP");
   //   -  
   if(!last_loaded) create_interface();
//---
   return(0);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---
   //   -     
   if(reason!=REASON_CHARTCHANGE)
     {
      //  
      last_loaded=false;  
      //   
      ObjectsDeleteAll_my("ActP");
      //     
      FileDelete("Active_Panel_scheme_custom_1.bin");
      FileDelete("Active_Panel_scheme_custom_2.bin");
      FileDelete("Active_Panel_scheme_custom_3.bin");
      FileDelete("Active_Panel_scheme_custom_4.bin");
      FileDelete("Active_Panel_scheme_custom_5.bin");
     }
   //  
   else last_loaded=true;
   // 
   EventKillTimer();
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
   //  
   get_prices();
  }
//+------------------------------------------------------------------+
//|                                                 |
//+------------------------------------------------------------------+
void OnTimer()
  {
  //  1
   if(ObjectGetInteger(0,"ActP_main_1",OBJPROP_STATE)==1)
     {
      //   
      if(ObjectGetInteger(0,"ActP_DealLines_check1",OBJPROP_STATE)==1) 
        {
         //      
         double sl_pr=NormalizeDouble(ObjectGetDouble(0,"ActP_SL_line1",OBJPROP_PRICE),_Digits);
         //
         ObjectSetString(0,"ActP_SL_edit1",OBJPROP_TEXT,DoubleToString(sl_pr,_Digits)); 

         double tp_pr=NormalizeDouble(ObjectGetDouble(0,"ActP_TP_line1",OBJPROP_PRICE),_Digits);
         // 
         ObjectSetString(0,"ActP_TP_edit1",OBJPROP_TEXT,DoubleToString(tp_pr,_Digits)); 
        }
     }

   //    
   if(ObjectGetInteger(0,"ActP_main_2",OBJPROP_STATE)==1)
     {
      if(ObjectGetInteger(0,"ActP_DealLines_check2",OBJPROP_STATE)==1)
        {
         double sl_pr=NormalizeDouble(ObjectGetDouble(0,"ActP_SL_line2",OBJPROP_PRICE),_Digits);
         ObjectSetString(0,"ActP_SL_edit2",OBJPROP_TEXT,DoubleToString(sl_pr,_Digits));

         double tp_pr=NormalizeDouble(ObjectGetDouble(0,"ActP_TP_line2",OBJPROP_PRICE),_Digits);
         ObjectSetString(0,"ActP_TP_edit2",OBJPROP_TEXT,DoubleToString(tp_pr,_Digits));

         double op_pr=NormalizeDouble(ObjectGetDouble(0,"ActP_op_line2",OBJPROP_PRICE),_Digits);
         ObjectSetString(0,"ActP_Pr_edit2",OBJPROP_TEXT,DoubleToString(op_pr,_Digits));

         //     stoplimit
         if(ObjectGetInteger(0,"ActP_limit_check2",OBJPROP_STATE)==1)
           {
            double lim_pr=NormalizeDouble(ObjectGetDouble(0,"ActP_lim_line2",OBJPROP_PRICE),_Digits);
            ObjectSetString(0,"ActP_limpr_edit2",OBJPROP_TEXT,DoubleToString(lim_pr,_Digits));
           }

         //      
         if(ObjectGetInteger(0,"ActP_exp3_radio2",OBJPROP_STATE)==1)
            ObjectSetString(0,"ActP_exp_edit2",OBJPROP_TEXT,TimeToString(ObjectGetInteger(0,"ActP_exp_line2",OBJPROP_TIME)));
        }
     }

   if(ObjectGetInteger(0,"ActP_main_3",OBJPROP_STATE)==1)
     {
      if(ObjectGetInteger(0,"ActP_DealLines_check4",OBJPROP_STATE)==1)
        {
         double sl_pr=NormalizeDouble(ObjectGetDouble(0,"ActP_SL_line4",OBJPROP_PRICE),_Digits);
         ObjectSetString(0,"ActP_SL_edit4",OBJPROP_TEXT,DoubleToString(sl_pr,_Digits));

         double tp_pr=NormalizeDouble(ObjectGetDouble(0,"ActP_TP_line4",OBJPROP_PRICE),_Digits);
         ObjectSetString(0,"ActP_TP_edit4",OBJPROP_TEXT,DoubleToString(tp_pr,_Digits));

         double op_pr=NormalizeDouble(ObjectGetDouble(0,"ActP_op_line4",OBJPROP_PRICE),_Digits);
         ObjectSetString(0,"ActP_Pr_edit4",OBJPROP_TEXT,DoubleToString(op_pr,_Digits));
        }

      if(ObjectGetInteger(0,"ActP_DealLines_check3",OBJPROP_STATE)==1)
        {
         double sl_pr=NormalizeDouble(ObjectGetDouble(0,"ActP_SL_line3",OBJPROP_PRICE),_Digits);
         ObjectSetString(0,"ActP_SL_edit3",OBJPROP_TEXT,DoubleToString(sl_pr,_Digits));

         double tp_pr=NormalizeDouble(ObjectGetDouble(0,"ActP_TP_line3",OBJPROP_PRICE),_Digits);
         ObjectSetString(0,"ActP_TP_edit3",OBJPROP_TEXT,DoubleToString(tp_pr,_Digits));

         double op_pr=NormalizeDouble(ObjectGetDouble(0,"ActP_op_line3",OBJPROP_PRICE),_Digits);
         ObjectSetString(0,"ActP_Pr_edit3",OBJPROP_TEXT,DoubleToString(op_pr,_Digits));

         if(ObjectGetInteger(0,"ActP_limit_check3",OBJPROP_STATE)==1)
           {
            double lim_pr=NormalizeDouble(ObjectGetDouble(0,"ActP_lim_line3",OBJPROP_PRICE),_Digits);
            ObjectSetString(0,"ActP_limpr_edit3",OBJPROP_TEXT,DoubleToString(lim_pr,_Digits));
           }

         if(ObjectGetInteger(0,"ActP_exp3_radio3",OBJPROP_STATE)==1)
            ObjectSetString(0,"ActP_exp_edit3",OBJPROP_TEXT,TimeToString(ObjectGetInteger(0,"ActP_exp_line3",OBJPROP_TIME)));
        }
     }
   // 
   ChartRedraw();
  }
//+------------------------------------------------------------------+
//|                                                |
//+------------------------------------------------------------------+
void OnChartEvent(const int id,const long &lparam,const double &dparam,const string &sparam)
  {
   // -   
   if(id==CHARTEVENT_CLICK)
     {
      //   
      DeleteLists("ActP_orders_list_"); 
      DeleteLists("ActP_color_list_");
      //       
      ObjectSetInteger(0,"ActP_ord_button5",OBJPROP_STATE,0);
      ObjectSetInteger(0,"ActP_col1_button6",OBJPROP_STATE,0);
      ObjectSetInteger(0,"ActP_col2_button6",OBJPROP_STATE,0);
      ObjectSetInteger(0,"ActP_col3_button6",OBJPROP_STATE,0);
      ChartRedraw();
      return;
     }

   // -    
   if(id==CHARTEVENT_OBJECT_ENDEDIT)
     {
      //******************************************
      //   -        
      if(sparam=="ActP_SL_edit1")
        {
         //     
         if(ObjectGetInteger(0,"ActP_DealLines_check1",OBJPROP_STATE)==1)
           {
            //    
            double sl_val=StringToDouble(ObjectGetString(0,"ActP_SL_edit1",OBJPROP_TEXT));
            //    
            ObjectSetDouble(0,"ActP_SL_line1",OBJPROP_PRICE,sl_val);
           }
         // 
         ChartRedraw();
         //..         -    
         return;
        }
      //            
      if(sparam=="ActP_TP_edit1")
        {
         if(ObjectGetInteger(0,"ActP_DealLines_check1",OBJPROP_STATE)==1)
           {
            double tp_val=StringToDouble(ObjectGetString(0,"ActP_TP_edit1",OBJPROP_TEXT));
            ObjectSetDouble(0,"ActP_TP_line1",OBJPROP_PRICE,tp_val);
           }
         ChartRedraw();
         return;
        }
      //******************************************
      if(sparam=="ActP_SL_edit2")
        {
         if(ObjectGetInteger(0,"ActP_DealLines_check2",OBJPROP_STATE)==1)
           {
            double sl_val=StringToDouble(ObjectGetString(0,"ActP_SL_edit2",OBJPROP_TEXT));
            ObjectSetDouble(0,"ActP_SL_line2",OBJPROP_PRICE,sl_val);
           }
         ChartRedraw();
         return;
        }
      if(sparam=="ActP_TP_edit2")
        {
         if(ObjectGetInteger(0,"ActP_DealLines_check2",OBJPROP_STATE)==1)
           {
            double tp_val=StringToDouble(ObjectGetString(0,"ActP_TP_edit2",OBJPROP_TEXT));
            ObjectSetDouble(0,"ActP_TP_line2",OBJPROP_PRICE,tp_val);
           }
         ChartRedraw();
         return;
        }
      if(sparam=="ActP_Pr_edit2")
        {
         if(ObjectGetInteger(0,"ActP_DealLines_check2",OBJPROP_STATE)==1)
           {
            double op_val=StringToDouble(ObjectGetString(0,"ActP_Pr_edit2",OBJPROP_TEXT));
            ObjectSetDouble(0,"ActP_op_line2",OBJPROP_PRICE,op_val);
           }
         ChartRedraw();
         return;
        }
      if(sparam=="ActP_limpr_edit2")
        {
         if(ObjectGetInteger(0,"ActP_DealLines_check2",OBJPROP_STATE)==1)
           {
            double lim_val=StringToDouble(ObjectGetString(0,"ActP_limpr_edit2",OBJPROP_TEXT));
            ObjectSetDouble(0,"ActP_lim_line2",OBJPROP_PRICE,lim_val);
           }
         ChartRedraw();
         return;
        }
      if(sparam=="ActP_exp_edit2")
        {
         if(ObjectGetInteger(0,"ActP_DealLines_check2",OBJPROP_STATE)==1)
           {
            datetime exp_val=StringToTime(ObjectGetString(0,"ActP_exp_edit2",OBJPROP_TEXT));
            ObjectSetInteger(0,"ActP_exp_line2",OBJPROP_TIME,exp_val);
           }
         ChartRedraw();
         return;
        }
      //******************************************      
      if(sparam=="ActP_SL_edit4")
        {
         if(ObjectGetInteger(0,"ActP_DealLines_check4",OBJPROP_STATE)==1)
           {
            double sl_val=StringToDouble(ObjectGetString(0,"ActP_SL_edit4",OBJPROP_TEXT));
            ObjectSetDouble(0,"ActP_SL_line4",OBJPROP_PRICE,sl_val);
           }
         ChartRedraw();
         return;
        }
      if(sparam=="ActP_TP_edit4")
        {
         if(ObjectGetInteger(0,"ActP_DealLines_check4",OBJPROP_STATE)==1)
           {
            double tp_val=StringToDouble(ObjectGetString(0,"ActP_TP_edit4",OBJPROP_TEXT));
            ObjectSetDouble(0,"ActP_TP_line4",OBJPROP_PRICE,tp_val);
           }
         ChartRedraw();
         return;
        }
      //******************************************   
      if(sparam=="ActP_SL_edit3")
        {
         if(ObjectGetInteger(0,"ActP_DealLines_check3",OBJPROP_STATE)==1)
           {
            double sl_val=StringToDouble(ObjectGetString(0,"ActP_SL_edit3",OBJPROP_TEXT));
            ObjectSetDouble(0,"ActP_SL_line3",OBJPROP_PRICE,sl_val);
           }
         ChartRedraw();
         return;
        }
      if(sparam=="ActP_TP_edit3")
        {
         if(ObjectGetInteger(0,"ActP_DealLines_check3",OBJPROP_STATE)==1)
           {
            double tp_val=StringToDouble(ObjectGetString(0,"ActP_TP_edit3",OBJPROP_TEXT));
            ObjectSetDouble(0,"ActP_TP_line3",OBJPROP_PRICE,tp_val);
           }
         ChartRedraw();
         return;
        }
      if(sparam=="ActP_Pr_edit3")
        {
         if(ObjectGetInteger(0,"ActP_DealLines_check3",OBJPROP_STATE)==1)
           {
            double op_val=StringToDouble(ObjectGetString(0,"ActP_Pr_edit3",OBJPROP_TEXT));
            ObjectSetDouble(0,"ActP_op_line3",OBJPROP_PRICE,op_val);
           }
         ChartRedraw();
         return;
        }
      if(sparam=="ActP_limpr_edit3")
        {
         if(ObjectGetInteger(0,"ActP_DealLines_check3",OBJPROP_STATE)==1)
           {
            double lim_val=StringToDouble(ObjectGetString(0,"ActP_limpr_edit3",OBJPROP_TEXT));
            ObjectSetDouble(0,"ActP_lim_line3",OBJPROP_PRICE,lim_val);
           }
         ChartRedraw();
         return;
        }
      if(sparam=="ActP_exp_edit3")
        {
         if(ObjectGetInteger(0,"ActP_DealLines_check3",OBJPROP_STATE)==1)
           {
            datetime exp_val=StringToTime(ObjectGetString(0,"ActP_exp_edit3",OBJPROP_TEXT));
            ObjectSetInteger(0,"ActP_exp_line3",OBJPROP_TIME,exp_val);
           }
         ChartRedraw();
         return;
        }

      //     
      if(sparam=="ActP_font_edit6")
        {
        //     
         SetFontSize(int(StringToInteger(ObjectGetString(0,sparam,OBJPROP_TEXT))));
        }
      //******************************************          
     }

   // -    
   if(id==CHARTEVENT_OBJECT_CLICK)
     {
      //******************************************
      //   
      if(sparam=="ActP_buy_button1")
        {
         //  
         bool selected=ObjectGetInteger(0,sparam,OBJPROP_STATE);
         //    ""
         if(selected)
           {
            //  
            deal(ORDER_TYPE_BUY);
            //     ""
            ObjectSetInteger(0,sparam,OBJPROP_STATE,0);
           }
         // 
         ChartRedraw();
         //   
         return;
        }
      //******************************************
      //   
      if(sparam=="ActP_sell_button1")
        {
         bool selected=ObjectGetInteger(0,sparam,OBJPROP_STATE);
         if(selected)
           {
            deal(ORDER_TYPE_SELL);
            ObjectSetInteger(0,sparam,OBJPROP_STATE,0);
           }
         ChartRedraw();
         return;
        }
      //******************************************
      //       
      if(sparam=="ActP_buy_button2")
        {
         //  
         bool selected=ObjectGetInteger(0,sparam,OBJPROP_STATE);
         // 
         if(selected)
           {
            ENUM_ORDER_TYPE typ;
            //      
            double pr=NormalizeDouble(StringToDouble(ObjectGetString(0,"ActP_Pr_edit2",OBJPROP_TEXT)),Digits());
            //     stoplimit
            if(ObjectGetInteger(0,"ActP_limit_check2",OBJPROP_STATE)==0)
              {
               //      limit  
               if(Ask>pr) typ=ORDER_TYPE_BUY_LIMIT;
               // - stop 
               else typ=ORDER_TYPE_BUY_STOP;
              }
            //    stoplimit
            else
              {
              //   
               typ=ORDER_TYPE_BUY_STOP_LIMIT; 
              }
            //  
            order(typ);
            //    ""
            ObjectSetInteger(0,sparam,OBJPROP_STATE,0);
           }
         // 
         ChartRedraw();
         //   
         return;
        }
      //******************************************  
      //      
      if(sparam=="ActP_sell_button2")
        {
         bool selected=ObjectGetInteger(0,sparam,OBJPROP_STATE);
         if(selected)
           {
            ENUM_ORDER_TYPE typ;
            double pr=NormalizeDouble(StringToDouble(ObjectGetString(0,"ActP_Pr_edit2",OBJPROP_TEXT)),Digits());
            if(ObjectGetInteger(0,"ActP_limit_check2",OBJPROP_STATE)==0)
              {
               if(Bid<pr) typ=ORDER_TYPE_SELL_LIMIT;
               else typ=ORDER_TYPE_SELL_STOP;
              }
            else
              {
               typ=ORDER_TYPE_SELL_STOP_LIMIT;
              }
            order(typ);
            ObjectSetInteger(0,sparam,OBJPROP_STATE,0);
           }
         ChartRedraw();
         return;
        }
      //******************************************        
      //     
      if(sparam=="ActP_mod_button4")
        {
         //  
         bool selected=ObjectGetInteger(0,sparam,OBJPROP_STATE);
         // 
         if(selected)
           {
            //
            modify_pos();
            //   
            DeleteScheme("ActP",true);
            //   (   )
            SetScheme(0);
            //    ""
            ObjectSetInteger(0,sparam,OBJPROP_STATE,0); 
           }
         //   
         ChartRedraw();
         //   
         return;
        }
      //******************************************        
      //     
      if(sparam=="ActP_del_button4")
        {
        //  
         bool selected=ObjectGetInteger(0,sparam,OBJPROP_STATE);
         // 
         if(selected)
           {
            // 
            ulong retcode=close_pos();
            // 
            if(retcode==10009)
              {
               //  
               DeleteScheme("ActP",true);
               //     
               ObjectSetString(0,"ActP_ord_button5",OBJPROP_TEXT,"  -->");
              }
            //    ""
            ObjectSetInteger(0,sparam,OBJPROP_STATE,0);
           }
         //   
         ChartRedraw();
         //   
         return;
        }
      //******************************************   
      //    
      if(sparam=="ActP_del_button3")
        {
         //  
         bool selected=ObjectGetInteger(0,sparam,OBJPROP_STATE);
         // 
         if(selected)
           {
           //      
            string button_name=ObjectGetString(0,"ActP_ord_button5",OBJPROP_TEXT);
            long ticket=StringToInteger(StringSubstr(button_name, 1, StringFind(button_name, " ")-1));
            //  
            ulong retcode=del_order(int(ticket));
            //  
            if(retcode==10009)
              {
               //  
               DeleteScheme("ActP",true);
               //     
               ObjectSetString(0,"ActP_ord_button5",OBJPROP_TEXT,"  -->");
              }
            //    ""
            ObjectSetInteger(0,sparam,OBJPROP_STATE,0);
           }
         //   
         ChartRedraw();
         //   
         return;
        }
      //****************************************** 
      //    
      if(sparam=="ActP_mod_button3")
        {
         bool selected=ObjectGetInteger(0,sparam,OBJPROP_STATE);
         if(selected)
           {
            //      
            string button_name=ObjectGetString(0,"ActP_ord_button5",OBJPROP_TEXT);
            long ticket=StringToInteger(StringSubstr(button_name,1,StringFind(button_name," ")-1));
            // 
            modify_order(int(ticket));
            // 
            DeleteScheme("ActP",true);
            SetScheme(int(ticket));
            //    ""
            ObjectSetInteger(0,sparam,OBJPROP_STATE,0);
           }
         //   
         ChartRedraw();
         //   
         return;
        }
      //******************************************                                     
      //     stoplimit
      if(sparam=="ActP_limit_check2")
        {
         //  
         bool selected=ObjectGetInteger(0,sparam,OBJPROP_STATE);
         //  
         if(selected)
           {
            //      
            ObjectSetInteger(0,"ActP_limpr_edit2",OBJPROP_BGCOLOR,White);
            //          
            ObjectSetInteger(0,"ActP_limpr_edit2",OBJPROP_READONLY,false);
            //     
            ObjectSetString(0,"ActP_limpr_edit2",OBJPROP_TEXT,DoubleToString(Bid,_Digits));
            //   
            //             
            if(ObjectGetInteger(0,"ActP_DealLines_check2",OBJPROP_STATE)==1)
               ObjectSetDouble(0,"ActP_lim_line2",OBJPROP_PRICE,Bid);
           }
         //    
         else
           {
            //    
            ObjectSetInteger(0,"ActP_limpr_edit2",OBJPROP_BGCOLOR,LavenderBlush);
            // 
            ObjectSetInteger(0,"ActP_limpr_edit2",OBJPROP_READONLY,true);
            // "" 
            ObjectSetString(0,"ActP_limpr_edit2",OBJPROP_TEXT,"");
            //   
            //       
            if(ObjectGetInteger(0,"ActP_DealLines_check2",OBJPROP_STATE)==1)
               ObjectSetDouble(0,"ActP_lim_line2",OBJPROP_PRICE,0);
           }
        }
      //******************************************                
      //        
      if(sparam=="ActP_DealLines_check1")
        {
         //  
         bool selected=ObjectGetInteger(0,sparam,OBJPROP_STATE);
         //  
         if(selected)
           {
            //       
            string SL_txt=ObjectGetString(0,"ActP_SL_edit1",OBJPROP_TEXT);
            string TP_txt=ObjectGetString(0, "ActP_TP_edit1", OBJPROP_TEXT);
            double val_SL,val_TP;
            //     
            // 
            if(SL_txt!="")
               val_SL=StringToDouble(SL_txt);
            // 
            else
              {
              // .  .   
               double pr_max=ChartGetDouble(0,CHART_PRICE_MAX);
               double pr_min=ChartGetDouble(0, CHART_PRICE_MIN);
               //     
               val_SL=pr_min+(pr_max-pr_min)*0.33;
              }

            //  
            if(TP_txt!="")
               val_TP=StringToDouble(TP_txt);
            else
              {
               double pr_max=ChartGetDouble(0, CHART_PRICE_MAX);
               double pr_min=ChartGetDouble(0, CHART_PRICE_MIN);
               val_TP=pr_max-(pr_max-pr_min)*0.33;
              }
            //      
            ObjectSetDouble(0,"ActP_SL_line1",OBJPROP_PRICE,val_SL);
            ObjectSetDouble(0,"ActP_TP_line1",OBJPROP_PRICE,val_TP);
           }
         //  
         // 
         else
           {
            ObjectSetDouble(0,"ActP_SL_line1",OBJPROP_PRICE,0);
            ObjectSetDouble(0,"ActP_TP_line1",OBJPROP_PRICE,0);
           }
         //   
         ChartRedraw();
         //   
         return;
        }
      //******************************************
      //         
      if(sparam=="ActP_DealLines_check2")
        {
         //  
         bool selected=ObjectGetInteger(0,sparam,OBJPROP_STATE);
         //  
         if(selected)
           {
           //    
            string SL_txt=ObjectGetString(0,"ActP_SL_edit2",OBJPROP_TEXT);
            string TP_txt=ObjectGetString(0, "ActP_TP_edit2", OBJPROP_TEXT);
            string PR_txt=ObjectGetString(0, "ActP_Pr_edit2", OBJPROP_TEXT);
            string LIM_txt=ObjectGetString(0,"ActP_limpr_edit2",OBJPROP_TEXT);
            double val_SL,val_TP,val_op,val_lim;

            //     
            if(SL_txt!="")
               val_SL=StringToDouble(SL_txt);
            else
              {
               double pr_max=ChartGetDouble(0, CHART_PRICE_MAX);
               double pr_min=ChartGetDouble(0, CHART_PRICE_MIN);
               val_SL=pr_min+(pr_max-pr_min)*0.33;
              }

            if(TP_txt!="")
               val_TP=StringToDouble(TP_txt);
            else
              {
               double pr_max=ChartGetDouble(0, CHART_PRICE_MAX);
               double pr_min=ChartGetDouble(0, CHART_PRICE_MIN);
               val_TP=pr_max-(pr_max-pr_min)*0.33;
              }

            if(PR_txt!="")
               val_op=StringToDouble(PR_txt);
            else
              {
               double pr_max=ChartGetDouble(0, CHART_PRICE_MAX);
               double pr_min=ChartGetDouble(0, CHART_PRICE_MIN);
               val_op=pr_max-(pr_max-pr_min)*0.5;
              }

            if(LIM_txt!="")
               val_lim=StringToDouble(LIM_txt);
            else
              {
               double pr_max=ChartGetDouble(0, CHART_PRICE_MAX);
               double pr_min=ChartGetDouble(0, CHART_PRICE_MIN);
               val_lim=pr_min+(pr_max-pr_min)*0.25;
              }

            if(LIM_txt!="")
               val_lim=StringToDouble(LIM_txt);
            else
              {
               double pr_max=ChartGetDouble(0, CHART_PRICE_MAX);
               double pr_min=ChartGetDouble(0, CHART_PRICE_MIN);
               val_lim=pr_min+(pr_max-pr_min)*0.25;
              }

            datetime val_exp=StringToTime(ObjectGetString(0,"ActP_exp_edit2",OBJPROP_TEXT));

            ObjectSetDouble(0,"ActP_SL_line2",OBJPROP_PRICE,val_SL);
            ObjectSetDouble(0,"ActP_TP_line2",OBJPROP_PRICE,val_TP);
            ObjectSetDouble(0,"ActP_op_line2",OBJPROP_PRICE,val_op);
            ObjectSetDouble(0,"ActP_lim_line2",OBJPROP_PRICE,val_lim);
            ObjectSetInteger(0,"ActP_exp_line2",OBJPROP_TIME,val_exp);
           }
         else
           {
            ObjectSetDouble(0,"ActP_SL_line2",OBJPROP_PRICE,0);
            ObjectSetDouble(0,"ActP_TP_line2",OBJPROP_PRICE,0);
            ObjectSetDouble(0,"ActP_Pr_line2",OBJPROP_PRICE,0);
            ObjectSetDouble(0,"ActP_lim_line2",OBJPROP_PRICE,0);
            ObjectSetInteger(0,"ActP_exp_line2",OBJPROP_TIME,0);
           }
         ChartRedraw();
         return;
        }
      //******************************************     
      //         
      if(sparam=="ActP_DealLines_check3")
        {
         bool selected=ObjectGetInteger(0,sparam,OBJPROP_STATE);
         if(selected)
           {
            string SL_txt=ObjectGetString(0, "ActP_SL_edit3", OBJPROP_TEXT);
            string TP_txt=ObjectGetString(0, "ActP_TP_edit3", OBJPROP_TEXT);
            string PR_txt=ObjectGetString(0, "ActP_Pr_edit3", OBJPROP_TEXT);
            string LIM_txt=ObjectGetString(0,"ActP_limpr_edit3",OBJPROP_TEXT);
            double val_SL=StringToDouble(SL_txt), val_TP=StringToDouble(TP_txt);
            double val_op=StringToDouble(PR_txt), val_lim=StringToDouble(LIM_txt);
            datetime val_exp=StringToTime(ObjectGetString(0,"ActP_exp_edit3",OBJPROP_TEXT));

            ObjectSetDouble(0,"ActP_SL_line3",OBJPROP_PRICE,val_SL);
            ObjectSetDouble(0,"ActP_TP_line3",OBJPROP_PRICE,val_TP);
            ObjectSetDouble(0,"ActP_op_line3",OBJPROP_PRICE,val_op);
            ObjectSetDouble(0,"ActP_lim_line3",OBJPROP_PRICE,val_lim);
            ObjectSetInteger(0,"ActP_exp_line3",OBJPROP_TIME,val_exp);
           }
         else
           {
            ObjectSetDouble(0,"ActP_SL_line3",OBJPROP_PRICE,0);
            ObjectSetDouble(0,"ActP_TP_line3",OBJPROP_PRICE,0);
            ObjectSetDouble(0,"ActP_Pr_line3",OBJPROP_PRICE,0);
            ObjectSetDouble(0,"ActP_lim_line3",OBJPROP_PRICE,0);
            ObjectSetInteger(0,"ActP_exp_line3",OBJPROP_TIME,0);
           }
         ChartRedraw();
         return;
        }
      //******************************************
      //         
      if(sparam=="ActP_DealLines_check4")
        {
         bool selected=ObjectGetInteger(0,sparam,OBJPROP_STATE);
         if(selected)
           {
            double op_pr=StringToDouble(ObjectGetString(0,"ActP_Pr_edit4",OBJPROP_TEXT));
            double sl=StringToDouble(ObjectGetString(0, "ActP_SL_edit4", OBJPROP_TEXT));
            double tp=StringToDouble(ObjectGetString(0, "ActP_TP_edit4", OBJPROP_TEXT));
            ObjectSetDouble(0,"ActP_op_line4",OBJPROP_PRICE,op_pr);
            ObjectSetDouble(0,"ActP_SL_line4",OBJPROP_PRICE,sl);
            ObjectSetDouble(0,"ActP_TP_line4",OBJPROP_PRICE,tp);
           }
         else
           {
            ObjectSetDouble(0,"ActP_op_line4",OBJPROP_PRICE,0);
            ObjectSetDouble(0,"ActP_SL_line4",OBJPROP_PRICE,0);
            ObjectSetDouble(0,"ActP_TP_line4",OBJPROP_PRICE,0);
           }
         ChartRedraw();
         return;
        }
      //******************************************
      //   1      
      if(sparam=="ActP_Exe1_radio1")
        {
        //  
         bool selected=ObjectGetInteger(0,sparam,OBJPROP_STATE);
         //    
         ObjectSetInteger(0,sparam,OBJPROP_STATE,1);
         //    1  2-
         if(selected)
           {
            //  
            ObjectSetInteger(0,"ActP_Exe2_radio1",OBJPROP_STATE,false);
            // 
            ChartRedraw();
            //   
            return;
           }
         //   
         ChartRedraw();
         //  
         return;
        }

      //   2 
      if(sparam=="ActP_Exe2_radio1")
        {
         bool selected=ObjectGetInteger(0,sparam,OBJPROP_STATE);
         ObjectSetInteger(0,sparam,OBJPROP_STATE,1);
         if(selected)
           {
            ObjectSetInteger(0,"ActP_Exe1_radio1",OBJPROP_STATE,false);
            ChartRedraw();
            return;
           }
         ChartRedraw();
         return;
        }
      //******************************************
      //   1   
      if(sparam=="ActP_Exe1_radio2")
        {
         //  
         bool selected=ObjectGetInteger(0,sparam,OBJPROP_STATE);
         //    
         ObjectSetInteger(0,sparam,OBJPROP_STATE,1);
         //    1  3-
         if(selected)
           {
            //  
            ObjectSetInteger(0,"ActP_Exe2_radio2",OBJPROP_STATE,false);
            ObjectSetInteger(0,"ActP_Exe3_radio2",OBJPROP_STATE,false);
            // 
            ChartRedraw();
            //  
            return;
           }
         //   
         ChartRedraw();
         //  
         return;
        }

      //   2  
      if(sparam=="ActP_Exe2_radio2")
        {
         bool selected=ObjectGetInteger(0,sparam,OBJPROP_STATE);
         ObjectSetInteger(0,sparam,OBJPROP_STATE,1);
         if(selected)
           {
            ObjectSetInteger(0,"ActP_Exe1_radio2",OBJPROP_STATE,false);
            ObjectSetInteger(0,"ActP_Exe3_radio2",OBJPROP_STATE,false);
            ChartRedraw();
            return;
           }
         ChartRedraw();
         return;
        }

      //   3
      if(sparam=="ActP_Exe3_radio2")
        {
         bool selected=ObjectGetInteger(0,sparam,OBJPROP_STATE);
         ObjectSetInteger(0,sparam,OBJPROP_STATE,1);
         if(selected)
           {
            ObjectSetInteger(0,"ActP_Exe1_radio2",OBJPROP_STATE,false);
            ObjectSetInteger(0,"ActP_Exe2_radio2",OBJPROP_STATE,false);
            ChartRedraw();
            return;
           }
         ChartRedraw();
         return;
        }
      //******************************************
      if(sparam=="ActP_exp1_radio2")
        {
         bool selected=ObjectGetInteger(0,sparam,OBJPROP_STATE);
         ObjectSetInteger(0,sparam,OBJPROP_STATE,1);
         if(selected)
           {
            ObjectSetInteger(0,"ActP_exp2_radio2",OBJPROP_STATE,false);
            ObjectSetInteger(0,"ActP_exp3_radio2",OBJPROP_STATE,false);
            ObjectSetInteger(0,"ActP_exp_edit2",OBJPROP_BGCOLOR,LavenderBlush);
            ObjectSetInteger(0,"ActP_exp_edit2",OBJPROP_READONLY,true);
            ObjectSetString(0,"ActP_exp_edit2",OBJPROP_TEXT,"");
            if(ObjectGetInteger(0,"ActP_DealLines_check2",OBJPROP_STATE)==1)
               ObjectSetInteger(0,"ActP_exp_line2",OBJPROP_TIME,0);
            ChartRedraw();
            return;
           }
         ChartRedraw();
         return;
        }

      if(sparam=="ActP_exp2_radio2")
        {
         bool selected=ObjectGetInteger(0,sparam,OBJPROP_STATE);
         ObjectSetInteger(0,sparam,OBJPROP_STATE,1);
         if(selected)
           {
            ObjectSetInteger(0,"ActP_exp1_radio2",OBJPROP_STATE,false);
            ObjectSetInteger(0,"ActP_exp3_radio2",OBJPROP_STATE,false);
            ObjectSetInteger(0,"ActP_exp_edit2",OBJPROP_BGCOLOR,LavenderBlush);
            ObjectSetInteger(0,"ActP_exp_edit2",OBJPROP_READONLY,true);
            ObjectSetString(0,"ActP_exp_edit2",OBJPROP_TEXT,"");
            if(ObjectGetInteger(0,"ActP_DealLines_check2",OBJPROP_STATE)==1)
               ObjectSetInteger(0,"ActP_exp_line2",OBJPROP_TIME,0);
            ChartRedraw();
            return;
           }
         ChartRedraw();
         return;
        }

      if(sparam=="ActP_exp3_radio2")
        {
         bool selected=ObjectGetInteger(0,sparam,OBJPROP_STATE);
         ObjectSetInteger(0,sparam,OBJPROP_STATE,1);
         if(selected)
           {
            ObjectSetInteger(0,"ActP_exp1_radio2",OBJPROP_STATE,false);
            ObjectSetInteger(0,"ActP_exp2_radio2",OBJPROP_STATE,false);
            ObjectSetInteger(0,"ActP_exp_edit2",OBJPROP_BGCOLOR,White);
            ObjectSetInteger(0,"ActP_exp_edit2",OBJPROP_READONLY,false);
            ObjectSetString(0,"ActP_exp_edit2",OBJPROP_TEXT,TimeToString(time_current));
            if(ObjectGetInteger(0,"ActP_DealLines_check2",OBJPROP_STATE)==1)
               ObjectSetInteger(0,"ActP_exp_line2",OBJPROP_TIME,time_current);
            ChartRedraw();
            return;
           }
         else
           {
            ObjectSetInteger(0,"ActP_exp_edit2",OBJPROP_BGCOLOR,LavenderBlush);
            ObjectSetInteger(0,"ActP_exp_edit2",OBJPROP_READONLY,true);
            if(ObjectGetInteger(0,"ActP_DealLines_check2",OBJPROP_STATE)==1)
               ObjectSetInteger(0,"ActP_exp_line2",OBJPROP_TIME,0);
           }
         ChartRedraw();
         return;
        }
      //******************************************
      if(sparam=="ActP_exp1_radio3")
        {
         bool selected=ObjectGetInteger(0,sparam,OBJPROP_STATE);
         if(selected)
           {
            ObjectSetInteger(0,"ActP_exp2_radio3",OBJPROP_STATE,false);
            ObjectSetInteger(0,"ActP_exp3_radio3",OBJPROP_STATE,false);
            ObjectSetInteger(0,"ActP_exp_edit3",OBJPROP_BGCOLOR,LavenderBlush);
            ObjectSetInteger(0,"ActP_exp_edit3",OBJPROP_READONLY,true);
            ObjectSetString(0,"ActP_exp_edit3",OBJPROP_TEXT,"");
            if(ObjectGetInteger(0,"ActP_DealLines_check3",OBJPROP_STATE)==1)
               ObjectSetInteger(0,"ActP_exp_line3",OBJPROP_TIME,0);
            ChartRedraw();
            return;
           }
        }

      if(sparam=="ActP_exp2_radio3")
        {
         bool selected=ObjectGetInteger(0,sparam,OBJPROP_STATE);
         if(selected)
           {
            ObjectSetInteger(0,"ActP_exp1_radio3",OBJPROP_STATE,false);
            ObjectSetInteger(0,"ActP_exp3_radio3",OBJPROP_STATE,false);
            ObjectSetInteger(0,"ActP_exp_edit3",OBJPROP_BGCOLOR,LavenderBlush);
            ObjectSetInteger(0,"ActP_exp_edit3",OBJPROP_READONLY,true);
            ObjectSetString(0,"ActP_exp_edit3",OBJPROP_TEXT,"");
            if(ObjectGetInteger(0,"ActP_DealLines_check3",OBJPROP_STATE)==1)
               ObjectSetInteger(0,"ActP_exp_line3",OBJPROP_TIME,0);
            ChartRedraw();
            return;
           }
        }

      if(sparam=="ActP_exp3_radio3")
        {
         bool selected=ObjectGetInteger(0,sparam,OBJPROP_STATE);
         ObjectSetInteger(0,sparam,OBJPROP_STATE,1);
         if(selected)
           {
            ObjectSetInteger(0,"ActP_exp1_radio3",OBJPROP_STATE,false);
            ObjectSetInteger(0,"ActP_exp2_radio3",OBJPROP_STATE,false);
            ObjectSetInteger(0,"ActP_exp_edit3",OBJPROP_BGCOLOR,White);
            ObjectSetInteger(0,"ActP_exp_edit3",OBJPROP_READONLY,false);
            ObjectSetString(0,"ActP_exp_edit3",OBJPROP_TEXT,TimeToString(time_current));
            if(ObjectGetInteger(0,"ActP_DealLines_check3",OBJPROP_STATE)==1)
               ObjectSetInteger(0,"ActP_exp_line3",OBJPROP_TIME,time_current);
            ChartRedraw();
            return;
           }
         else
           {
            ObjectSetInteger(0,"ActP_exp_edit3",OBJPROP_BGCOLOR,LavenderBlush);
            ObjectSetInteger(0,"ActP_exp_edit3",OBJPROP_READONLY,true);
            if(ObjectGetInteger(0,"ActP_DealLines_check3",OBJPROP_STATE)==1)
               ObjectSetInteger(0,"ActP_exp_line3",OBJPROP_TIME,0);
           }
         ChartRedraw();
         return;
        }
      //******************************************      
      //  
      //   
      if(sparam=="ActP_main_1") {Main_controls_click(1); ChartRedraw(); return;}
      if(sparam=="ActP_main_2") {Main_controls_click(2); ChartRedraw(); return;}
      if(sparam=="ActP_main_3") {Main_controls_click(3); ChartRedraw(); return;}
      if(sparam=="ActP_main_4") {Main_controls_click(4); ChartRedraw(); return;}
      if(sparam=="ActP_main_5") {Main_controls_click(5); ChartRedraw(); return;}
      //******************************************
      //       
      if(sparam=="ActP_ord_button5")
        {
         // 
         bool selected=ObjectGetInteger(0,sparam,OBJPROP_STATE);
         // 
         if(selected)
           {
            // 
            DeleteScheme("ActP",true);
            //     
            string info[100];
            //  
            ulong tickets[100];
            // 
            ArrayInitialize(tickets,-1);
            // 
            get_ord_info(info, tickets);
            //  
            create_list(info,tickets);
           }
         //   
         else
           {
            //  
            DeleteLists("ActP_orders_list_");
           }
         //   
         ChartRedraw();
         //  
         return;
        }
      //******************************************       
      //      
      if(StringFind(sparam,"ActP_orders_list_")<0)
        {
         //  
         DeleteLists("ActP_orders_list_");
         //     ""
         ObjectSetInteger(0,"ActP_ord_button5",OBJPROP_STATE,0);
         // 
         ChartRedraw();
        }
      //       
      else
        {
         //     
         ObjectSetString(0,"ActP_ord_button5",OBJPROP_TEXT,ObjectGetString(0,sparam,OBJPROP_TEXT));
         //     ""
         ObjectSetInteger(0,"ActP_ord_button5",OBJPROP_STATE,0);
         //     
         int ticket=int(StringToInteger(StringSubstr(sparam,StringFind(sparam,"$")+1)));
         // 
         SetScheme(ticket);
         //   
         DeleteLists("ActP_orders_list_");
         // 
         ChartRedraw();
        }
      //******************************************   
      //        
      if(sparam=="ActP_col1_button6")
        {
        // 
         bool selected=ObjectGetInteger(0,sparam,OBJPROP_STATE);
         // 
         if(selected)
           {
            // 
            create_color_list(100,"ActP_col1_button6",1);
            //      ""
            ObjectSetInteger(0,"ActP_col2_button6",OBJPROP_STATE,0);
            ObjectSetInteger(0,"ActP_col3_button6",OBJPROP_STATE,0);
            //  
            DeleteLists("ActP_color_list_2");
            DeleteLists("ActP_color_list_3");
           }
         //   
         else
           {
            // 
            DeleteLists("ActP_color_list_"); 
           }
         //   
         ChartRedraw();
         //  
         return;
        }
      //******************************************
      //      
      if(StringFind(sparam,"ActP_color_list_1")<0)
        {
         // 
         DeleteLists("ActP_color_list_1"); 
         //     ""
         ObjectSetInteger(0,"ActP_col1_button6",OBJPROP_STATE,0);
         // 
         ChartRedraw(); 
        }
      //       
      else
        {
         //    
         color col=color(ObjectGetInteger(0,sparam,OBJPROP_BGCOLOR));
         //     
         SetButtonsColor(col);
         //     ""
         ObjectSetInteger(0,"ActP_col1_button6",OBJPROP_STATE,0);
         //  
         DeleteLists("ActP_color_list_1");
         // 
         ChartRedraw();
        }
      //******************************************     
      //     
      if(sparam=="ActP_col2_button6")
        {
         bool selected=ObjectGetInteger(0,sparam,OBJPROP_STATE);
         if(selected)
           {
            create_color_list(100,"ActP_col2_button6",2);
            //      ""
            ObjectSetInteger(0,"ActP_col1_button6",OBJPROP_STATE,0);
            ObjectSetInteger(0,"ActP_col3_button6",OBJPROP_STATE,0);
            //  
            DeleteLists("ActP_color_list_3");
            DeleteLists("ActP_color_list_1");
           }
         else
           {
            DeleteLists("ActP_color_list_2");
           }
         ChartRedraw();
         return;
        }
      //******************************************
      if(StringFind(sparam,"ActP_color_list_2")<0)
        {
         DeleteLists("ActP_color_list_2");
         ObjectSetInteger(0,"ActP_col2_button6",OBJPROP_STATE,0);
         ChartRedraw();
         //return;
        }
      else
        {
         color col=color(ObjectGetInteger(0,sparam,OBJPROP_BGCOLOR));
         SetLabelsColor(col);
         ObjectSetInteger(0,"ActP_col2_button6",OBJPROP_STATE,0);
         DeleteLists("ActP_color_list_2");
         ChartRedraw();
        }
      //******************************************     
      if(sparam=="ActP_col3_button6")
        {
         bool selected=ObjectGetInteger(0,sparam,OBJPROP_STATE);
         if(selected)
           {
            create_color_list(100,"ActP_col3_button6",3);
            //      ""
            ObjectSetInteger(0,"ActP_col2_button6",OBJPROP_STATE,0);
            ObjectSetInteger(0,"ActP_col1_button6",OBJPROP_STATE,0);
            //  
            DeleteLists("ActP_color_list_2");
            DeleteLists("ActP_color_list_1");
           }
         else
           {
            DeleteLists("ActP_color_list_3");
           }
         ChartRedraw();
         return;
        }
      //******************************************
      if(StringFind(sparam,"ActP_color_list_3")<0)
        {
         DeleteLists("ActP_color_list_3");
         ObjectSetInteger(0,"ActP_col3_button6",OBJPROP_STATE,0);
         ChartRedraw();
        }
      else
        {
         color col=color(ObjectGetInteger(0,sparam,OBJPROP_BGCOLOR));
         SetTextColor(col);
         ObjectSetInteger(0,"ActP_col3_button6",OBJPROP_STATE,0);
         DeleteLists("ActP_color_list_3");
         ChartRedraw();
        }
      //******************************************                 
     }
  }
//+------------------------------------------------------------------+
//|                                       |
//| col -                                               |
//+------------------------------------------------------------------+
void SetButtonsColor(color col)
  {
   //  
   for(int i=ObjectsTotal(0);i>=0;i--)
     {
      string n=ObjectName(0,i);
      //      
      // 
      if(StringFind(n,"ActP")>=0 && ObjectGetInteger(0,n,OBJPROP_TYPE)==OBJ_BUTTON) 
         ObjectSetInteger(0,n,OBJPROP_BGCOLOR,col); 
     }
   //  
   GlobalVariableSet("ActP_buttons_color",col);
  }
//+------------------------------------------------------------------+
//|                                        |
//| col -                                                |
//+------------------------------------------------------------------+
void SetLabelsColor(color col)
  {
   //  
   for(int i=ObjectsTotal(0);i>=0;i--)
     {
      string n=ObjectName(0,i);
      //      
      // 
      if(StringFind(n,"ActP")>=0 && ObjectGetInteger(0,n,OBJPROP_TYPE)==OBJ_LABEL) 
         ObjectSetInteger(0,n,OBJPROP_COLOR,col); 
     }
   //    
   GlobalVariableSet("ActP_label_color",col);
  }
//+------------------------------------------------------------------+
//|                      |
//| col -                                               |
//+------------------------------------------------------------------+
void SetTextColor(color col)
  {
   //  
   for(int i=ObjectsTotal(0);i>=0;i--)
     {
      string n=ObjectName(0,i);
      long obj_type=ObjectGetInteger(0,n,OBJPROP_TYPE);
      //         
      // 
      if(StringFind(n,"ActP")>=0 && (obj_type==OBJ_BUTTON || obj_type==OBJ_EDIT)) 
         ObjectSetInteger(0,n,OBJPROP_COLOR,col); 
     }
   //    
   GlobalVariableSet("ActP_text_color",col);
  }
//+------------------------------------------------------------------+
//|                                     |
//| font_size -                           |
//+------------------------------------------------------------------+
void SetFontSize(int font_size)
  {
   //    -  
   if(font_size>10) font_size=10;
   //  
   for(int i=ObjectsTotal(0);i>=0;i--)
     {
      string n=ObjectName(0,i);
      int obj_type=int(ObjectGetInteger(0,n,OBJPROP_TYPE));
      //         
      //  
      if(StringFind(n,"ActP")>=0 && (obj_type==OBJ_EDIT || obj_type==OBJ_LABEL)) 
         ObjectSetInteger(0,n,OBJPROP_FONTSIZE,font_size); 
     }
   //    
   GlobalVariableSet("ActP_font_size",font_size);
  }
//+------------------------------------------------------------------+
//|              |
//+------------------------------------------------------------------+
void SetPositionParams()
  {
   //  
   if(PositionSelect(Symbol()))
     {
      //  
      double pr=PositionGetDouble(POSITION_PRICE_OPEN);
      double lots=PositionGetDouble(POSITION_VOLUME);
      double sl=PositionGetDouble(POSITION_SL);
      double tp=PositionGetDouble(POSITION_TP);
      long mag=PositionGetInteger(POSITION_MAGIC);
      //     
      ObjectSetString(0,"ActP_Pr_edit4",OBJPROP_TEXT,str_del_zero(DoubleToString(pr)));
      ObjectSetString(0,"ActP_lots_edit4",OBJPROP_TEXT,str_del_zero(DoubleToString(lots)));
      ObjectSetString(0,"ActP_SL_edit4",OBJPROP_TEXT,str_del_zero(DoubleToString(sl)));
      ObjectSetString(0,"ActP_TP_edit4",OBJPROP_TEXT,str_del_zero(DoubleToString(tp)));
      if(mag!=0) ObjectSetString(0,"ActP_mag_edit4",OBJPROP_TEXT,IntegerToString(mag));
      // 
      ChartRedraw();
     }
   //  ,    
   else MessageBox("     "+Symbol());
  }
//+------------------------------------------------------------------+
//|              |
//| ticket -                                              |
//+------------------------------------------------------------------+
void SetOrderParams(int ticket)
  {
   //  
   if(OrderSelect(ticket) && OrderGetString(ORDER_SYMBOL)==Symbol())
     {
      //  
      double pr=OrderGetDouble(ORDER_PRICE_OPEN);
      double lots=OrderGetDouble(ORDER_VOLUME_CURRENT);
      double sl=OrderGetDouble(ORDER_SL);
      double tp=OrderGetDouble(ORDER_TP);
      long mag=OrderGetInteger(ORDER_MAGIC);
      double lim=OrderGetDouble(ORDER_PRICE_STOPLIMIT);
      datetime expir=datetime(OrderGetInteger(ORDER_TIME_EXPIRATION));
      ENUM_ORDER_TYPE type=ENUM_ORDER_TYPE (OrderGetInteger(ORDER_TYPE));
      ENUM_ORDER_TYPE_TIME expir_type=ENUM_ORDER_TYPE_TIME(OrderGetInteger(ORDER_TYPE_TIME));
      
      //  stoplimit  
      if(type==ORDER_TYPE_BUY_STOP_LIMIT || type==ORDER_TYPE_SELL_STOP_LIMIT)
        {
         //        
         ObjectSetString(0,"ActP_limpr_edit3",OBJPROP_TEXT,DoubleToString(lim,_Digits));
         ObjectSetInteger(0,"ActP_limpr_edit3",OBJPROP_BGCOLOR,White);
         //        
         ObjectSetInteger(0,"ActP_limpr_edit3",OBJPROP_READONLY,false);
        }
      //   stoplimit        
      else
        {
         ObjectSetString(0,"ActP_limpr_edit3",OBJPROP_TEXT,"");
         ObjectSetInteger(0,"ActP_limpr_edit3",OBJPROP_BGCOLOR,LavenderBlush);
         ObjectSetInteger(0,"ActP_limpr_edit3",OBJPROP_READONLY,true);
        }

      //      
      //     
      switch(expir_type)
        {
         case ORDER_TIME_GTC:
           {
            ObjectSetInteger(0,"ActP_exp1_radio3",OBJPROP_STATE,1);
            ObjectSetInteger(0,"ActP_exp2_radio3",OBJPROP_STATE,0);
            ObjectSetInteger(0,"ActP_exp3_radio3",OBJPROP_STATE,0);
            break;
           }
         case ORDER_TIME_DAY:
           {
            ObjectSetInteger(0,"ActP_exp1_radio3",OBJPROP_STATE,0);
            ObjectSetInteger(0,"ActP_exp2_radio3",OBJPROP_STATE,1);
            ObjectSetInteger(0,"ActP_exp3_radio3",OBJPROP_STATE,0);
            break;
           }
         case ORDER_TIME_SPECIFIED:
           {
            ObjectSetInteger(0,"ActP_exp1_radio3",OBJPROP_STATE,0);
            ObjectSetInteger(0,"ActP_exp2_radio3",OBJPROP_STATE,0);
            ObjectSetInteger(0,"ActP_exp3_radio3",OBJPROP_STATE,1);
            //       
            ObjectSetString(0,"ActP_exp_edit3",OBJPROP_TEXT,TimeToString(expir));
            break;
           }
        }
      //    
      ObjectSetString(0,"ActP_Pr_edit3",OBJPROP_TEXT,str_del_zero(DoubleToString(pr)));
      ObjectSetString(0,"ActP_lots_edit3",OBJPROP_TEXT,str_del_zero(DoubleToString(lots)));
      ObjectSetString(0,"ActP_SL_edit3",OBJPROP_TEXT,str_del_zero(DoubleToString(sl)));
      ObjectSetString(0,"ActP_TP_edit3",OBJPROP_TEXT,str_del_zero(DoubleToString(tp)));
      ObjectSetString(0,"ActP_ticket_edit3",OBJPROP_TEXT,IntegerToString(ticket));
      if(mag!=0) ObjectSetString(0,"ActP_mag_edit3",OBJPROP_TEXT,IntegerToString(mag));
      ChartRedraw();
     }
   //  ,    
   else MessageBox("    "+IntegerToString(ticket)+"   "+Symbol());
  }

//+------------------------------------------------------------------+
//|               |
//| (   )                                    |
//| t -                                                         |
//+------------------------------------------------------------------+
void SetScheme(int t)
  {
   // 
   if(t==0)
     {
      //  
      if(PositionSelect(Symbol()))
        {
         //  
         DeleteScheme("ActP",true);
         //  
         ApplyScheme(6);
         //  
         SetPositionParams();
         //    
         Objects_Selectable("ActP",false);
        }
     }
   //   
   if(t>0)
     {
      //  
      if(OrderSelect(t))
        {
         //  
         DeleteScheme("ActP",true);
         //  
         ApplyScheme(7);
         //  
         SetOrderParams(t);
         //    
         Objects_Selectable("ActP",false);
        }
     }
  }
//+------------------------------------------------------------------+
//|                                      |
//| info -                                |
//| tickets -                                         |
//+------------------------------------------------------------------+
void create_list(string &info[],ulong &tickets[])
  {
   //    
   int x=int(ObjectGetInteger(0,"ActP_ord_button5",OBJPROP_XDISTANCE));
   int y=int(ObjectGetInteger(0, "ActP_ord_button5", OBJPROP_YDISTANCE)+ObjectGetInteger(0, "ActP_ord_button5", OBJPROP_YSIZE));
   // 
   color col=color(ObjectGetInteger(0,"ActP_ord_button5",OBJPROP_COLOR));
   color bgcol=color(ObjectGetInteger(0,"ActP_ord_button5",OBJPROP_BGCOLOR));
   //  
   int wnd_height=int(ChartGetInteger(0,CHART_HEIGHT_IN_PIXELS,wnd));
   int y_cnt=0;
   // 
   for(int i=0;i<100;i++)
     {
      //   -  
      if(tickets[i]==-1) break;
      //   
      int y_pos=y+y_cnt*20;
      //   ,   
      if(y_pos+20>wnd_height) {x+=300; y_cnt=0;}
      y_pos=y+y_cnt*20;
      y_cnt++;
      string name="ActP_orders_list_"+IntegerToString(i)+" $"+IntegerToString(tickets[i]);// 
      create_button(name,info[i],x,y_pos,300,20);
      //   
      ObjectSetInteger(0,name,OBJPROP_COLOR,col);
      ObjectSetInteger(0,name,OBJPROP_SELECTABLE,0);
      ObjectSetInteger(0,name,OBJPROP_STATE,0);
      ObjectSetInteger(0,name,OBJPROP_FONTSIZE,8);
      ObjectSetInteger(0,name,OBJPROP_BGCOLOR,bgcol);
     }
  }
//+------------------------------------------------------------------+
//|                                       |
//| y_max - .                                        |
//| ID -                                          |
//| num -                                             |
//+------------------------------------------------------------------+
void create_color_list(int y_max,string ID,int num)
  {
  //    
   int x=int(ObjectGetInteger(0,ID,OBJPROP_XDISTANCE));
   int y=int(ObjectGetInteger(0, ID, OBJPROP_YDISTANCE)+ObjectGetInteger(0, ID, OBJPROP_YSIZE));
   // 
   color col=color(ObjectGetInteger(0,ID,OBJPROP_COLOR));
   //  
   int wnd_height=int(ChartGetInteger(0,CHART_HEIGHT_IN_PIXELS,wnd));
   y_max+=y;
   int y_cnt=0;
   //   
   for(int i=0;i<132;i++)
     {
      color bgcol=colors[i];
      //   
      int y_pos=y+y_cnt*20;
      //   ,   
      if(y_pos+20>wnd_height || y_pos+20>y_max) {x+=20; y_cnt=0;}
      y_pos=y+y_cnt*20;
      y_cnt++;
      // 
      string name="ActP_color_list_"+IntegerToString(num)+ID+IntegerToString(i);
      create_button(name,"",x,y_pos,20,20);
      //   
      ObjectSetInteger(0,name,OBJPROP_COLOR,col);
      ObjectSetInteger(0,name,OBJPROP_SELECTABLE,0);
      ObjectSetInteger(0,name,OBJPROP_STATE,0);
      ObjectSetInteger(0,name,OBJPROP_BGCOLOR,bgcol);
     }
  }
//+------------------------------------------------------------------+
//|                               |
//+------------------------------------------------------------------+
void get_ord_info(string &info[],ulong &tickets[])
  {
   // 
   int cnt=0;
   string inf;
   //   
   if(PositionSelect(Symbol()))
     {
      //     
      double vol=PositionGetDouble(POSITION_VOLUME);
      int typ=int(PositionGetInteger(POSITION_TYPE));
      if(typ==POSITION_TYPE_BUY) inf+="BUY ";
      if(typ==POSITION_TYPE_SELL) inf+="SELL ";
      inf+=DoubleToString(vol, int(MathCeil(MathAbs(MathLog(vol)/MathLog(10)))))+" lots";
      inf+=" at "+DoubleToString(PositionGetDouble(POSITION_PRICE_OPEN), Digits());
      // 
      info[cnt]=inf;
      tickets[cnt]=0;
      // 
      cnt++;
     }

   //  
   for(int i=0;i<OrdersTotal();i++)
     {
      // 
      ulong ticket=OrderGetTicket(i);
      //      
      if(OrderGetString(ORDER_SYMBOL)==Symbol())
        {
         //     
         inf="#"+IntegerToString(ticket)+" ";
         int typ=int(OrderGetInteger(ORDER_TYPE));
         double vol=OrderGetDouble(ORDER_VOLUME_CURRENT);
         if(typ==ORDER_TYPE_BUY_LIMIT) inf+="BUY LIMIT ";
         if(typ==ORDER_TYPE_SELL_LIMIT) inf+="SELL LIMIT ";
         if(typ==ORDER_TYPE_BUY_STOP) inf+="BUY STOP ";
         if(typ==ORDER_TYPE_SELL_STOP) inf+="SELL STOP ";
         if(typ==ORDER_TYPE_BUY_STOP_LIMIT) inf+="BUY STOP LIMIT ";
         if(typ==ORDER_TYPE_SELL_STOP_LIMIT) inf+="SELL STOP LIMIT ";
         inf+=DoubleToString(vol, int(MathCeil(MathAbs(MathLog(vol)/MathLog(10)))))+" lots";
         inf+=" at "+DoubleToString(OrderGetDouble(ORDER_PRICE_OPEN), Digits());
         // 
         info[cnt]=inf;
         tickets[cnt]=ticket;
         // 
         cnt++;
        }
     }
  }
//+------------------------------------------------------------------+
//|                                                 |
//| ID -                                        |
//+------------------------------------------------------------------+
void Main_controls_click(int ID)
  {
   int loaded=ID;
   //  
   for(int i=1;i<6;i++)
     {
      // ,     
      if(i!=ID) 
        {
         //    
         if(ObjectGetInteger(0,"ActP_main_"+IntegerToString(i),OBJPROP_STATE)==1) loaded=i;
         ObjectSetInteger(0,"ActP_main_"+IntegerToString(i),OBJPROP_STATE,0);
        }
     }
//if(loaded==ID) return;
   //    
   ObjectSetInteger(0,"ActP_main_"+IntegerToString(ID),OBJPROP_STATE,1);
   //   
   DeleteLists("ActP_orders_list_"); 
   DeleteLists("ActP_color_list_");
   //       
   ObjectSetInteger(0,"ActP_ord_button5",OBJPROP_STATE,0);
   ObjectSetInteger(0,"ActP_col1_button6",OBJPROP_STATE,0);
   ObjectSetInteger(0,"ActP_col2_button6",OBJPROP_STATE,0);
   ObjectSetInteger(0,"ActP_col3_button6",OBJPROP_STATE,0);
   //   
   SaveScheme(loaded);
   //  
   DeleteScheme("ActP");
   //  
   ApplyScheme(ID);
   //     
   Objects_Selectable("ActP",false);
  }
//+------------------------------------------------------------------+
//|                                          |
//| ticket -                                              |
//+------------------------------------------------------------------+
ulong modify_order(int ticket)
  {
   //    
   double pr=StringToDouble(ObjectGetString(0,"ActP_Pr_edit3",OBJPROP_TEXT)); 
   double stoplim=StringToDouble(ObjectGetString(0,"ActP_limpr_edit3",OBJPROP_TEXT));
   double SL=StringToDouble(ObjectGetString(0, "ActP_SL_edit3", OBJPROP_TEXT));
   double TP=StringToDouble(ObjectGetString(0, "ActP_TP_edit3", OBJPROP_TEXT));
   double lots=StringToDouble(ObjectGetString(0,"ActP_Lots_edit3",OBJPROP_TEXT));
   datetime expir=StringToTime(ObjectGetString(0,"ActP_exp_edit3",OBJPROP_TEXT));
   ENUM_ORDER_TYPE_TIME expir_type=ORDER_TIME_GTC;
   if(ObjectGetInteger(0, "ActP_exp2_radio3", OBJPROP_STATE)==1) expir_type=ORDER_TIME_DAY;
   if(ObjectGetInteger(0, "ActP_exp3_radio3", OBJPROP_STATE)==1) expir_type=ORDER_TIME_SPECIFIED;

   //   
   MqlTradeRequest req;
   MqlTradeResult res;
   req.action=TRADE_ACTION_MODIFY;
   req.order=ticket;
   req.volume=lots;
   req.price=NormalizeDouble(pr,Digits());
   req.stoplimit=NormalizeDouble(stoplim,Digits());
   req.sl=NormalizeDouble(SL, Digits());
   req.tp=NormalizeDouble(TP, Digits());
   req.type_time=expir_type;
   req.expiration=expir;
   // 
   OrderSend(req,res);
   //   
   MessageBox(RetcodeDescription(res.retcode),"Message");
   //  
   return(res.retcode);
  }
//+------------------------------------------------------------------+
//|                                             |
//| ticket -                                              |
//+------------------------------------------------------------------+
ulong del_order(ulong ticket)
  {
   //   
   MqlTradeRequest req;
   MqlTradeResult res;
   req.action=TRADE_ACTION_REMOVE;
   req.order=ticket;
   // 
   OrderSend(req,res);
   //   
   MessageBox(RetcodeDescription(res.retcode),"Message");
   //  
   return(res.retcode);
  }
//+------------------------------------------------------------------+
//|                                          |
//+------------------------------------------------------------------+
ulong modify_pos()
  {
   if(!PositionSelect(Symbol())) MessageBox("     "+Symbol(),"Message");
   //    
   double SL=StringToDouble(ObjectGetString(0,"ActP_SL_edit4",OBJPROP_TEXT));  
   double TP=StringToDouble(ObjectGetString(0, "ActP_TP_edit4", OBJPROP_TEXT));
   int dev=int(StringToInteger(ObjectGetString(0,"ActP_dev_edit4",OBJPROP_TEXT)));
   // 
   MqlTradeRequest req;
   MqlTradeResult res;
   req.action=TRADE_ACTION_SLTP;
   req.symbol=Symbol();
   req.sl=NormalizeDouble(SL, _Digits);
   req.tp=NormalizeDouble(TP, _Digits);
   req.deviation=dev;
   // 
   OrderSend(req,res);
   //   
   MessageBox(RetcodeDescription(res.retcode),"Message");
   //  
   return(res.retcode);
  }
//+------------------------------------------------------------------+
//|                                             |
//+------------------------------------------------------------------+
ulong close_pos()
  {
   if(!PositionSelect(Symbol())) MessageBox("     "+Symbol(),"Message");
   //    
   double lots=StringToDouble(ObjectGetString(0,"ActP_lots_edit4",OBJPROP_TEXT));
   if(lots>PositionGetDouble(POSITION_VOLUME)) lots=PositionGetDouble(POSITION_VOLUME);
   int dev=int(StringToInteger(ObjectGetString(0, "ActP_dev_edit4", OBJPROP_TEXT)));
   int mag=int(StringToInteger(ObjectGetString(0, "ActP_mag_edit4", OBJPROP_TEXT)));

   // 
   MqlTradeRequest req;
   MqlTradeResult res;
   ZeroMemory(req);

   //      
   if(PositionGetInteger(POSITION_TYPE)==POSITION_TYPE_BUY)
     {
      req.price=Bid;
      req.type=ORDER_TYPE_SELL;
     }
   else
     {
      req.price=Ask;
      req.type=ORDER_TYPE_BUY;
     }

   req.action=TRADE_ACTION_DEAL;
   req.symbol=Symbol();
   req.volume=lots;
   req.sl=0;
   req.tp=0;
   req.deviation=dev;
   req.type_filling=ORDER_FILLING_FOK;
   req.magic=mag;
   // 
   OrderSend(req,res);
   //   
   MessageBox(RetcodeDescription(res.retcode),"Message");
   //   
   return(res.retcode);
  }
//+------------------------------------------------------------------+
//|                                             |
//+------------------------------------------------------------------+
ulong deal(ENUM_ORDER_TYPE typ)
  {
   //      
   double SL=StringToDouble(ObjectGetString(0,"ActP_SL_edit1",OBJPROP_TEXT));
   double TP=StringToDouble(ObjectGetString(0, "ActP_TP_edit1", OBJPROP_TEXT));
   double lots=StringToDouble(ObjectGetString(0,"ActP_Lots_edit1",OBJPROP_TEXT));
   int mag=int(StringToInteger(ObjectGetString(0, "ActP_Magic_edit1", OBJPROP_TEXT)));
   int dev=int(StringToInteger(ObjectGetString(0, "ActP_Dev_edit1", OBJPROP_TEXT)));
   string comm=ObjectGetString(0,"ActP_Comm_edit1",OBJPROP_TEXT);
   ENUM_ORDER_TYPE_FILLING filling=ORDER_FILLING_FOK;
   if(ObjectGetInteger(0,"ActP_Exe2_radio1",OBJPROP_STATE)==1) filling=ORDER_FILLING_IOC;

   // 
   MqlTradeRequest req;
   MqlTradeResult res;
   ZeroMemory(req);
   
   req.action=TRADE_ACTION_DEAL;
   req.symbol=Symbol();
   req.volume=lots;
   req.price=Ask;
   req.sl=NormalizeDouble(SL, Digits());
   req.tp=NormalizeDouble(TP, Digits());
   req.deviation=dev;
   req.type=typ;
   req.type_filling=filling;
   req.magic=mag;
   req.comment=comm;
   // 
   OrderSend(req,res);
   //   
   MessageBox(RetcodeDescription(res.retcode),"Message");
   //  
   return(res.retcode);
  }
//+------------------------------------------------------------------+
//|                                            |
//+------------------------------------------------------------------+
ulong order(ENUM_ORDER_TYPE typ)
  {
   //    
   double pr=StringToDouble(ObjectGetString(0,"ActP_Pr_edit2",OBJPROP_TEXT));
   double stoplim=StringToDouble(ObjectGetString(0,"ActP_limpr_edit2",OBJPROP_TEXT));
   double SL=StringToDouble(ObjectGetString(0, "ActP_SL_edit2", OBJPROP_TEXT));
   double TP=StringToDouble(ObjectGetString(0, "ActP_TP_edit2", OBJPROP_TEXT));
   double lots=StringToDouble(ObjectGetString(0,"ActP_Lots_edit2",OBJPROP_TEXT));
   datetime expir=StringToTime(ObjectGetString(0,"ActP_exp_edit2",OBJPROP_TEXT));
   int mag=int(StringToInteger(ObjectGetString(0,"ActP_Magic_edit2",OBJPROP_TEXT)));
   string comm=ObjectGetString(0,"ActP_Comm_edit2",OBJPROP_TEXT);
   ENUM_ORDER_TYPE_FILLING filling=ORDER_FILLING_FOK;
   if(ObjectGetInteger(0, "ActP_Exe2_radio2", OBJPROP_STATE)==1) filling=ORDER_FILLING_IOC;
   if(ObjectGetInteger(0, "ActP_Exe3_radio2", OBJPROP_STATE)==1) filling=ORDER_FILLING_RETURN;
   ENUM_ORDER_TYPE_TIME expir_type=ORDER_TIME_GTC;
   if(ObjectGetInteger(0, "ActP_exp2_radio2", OBJPROP_STATE)==1) expir_type=ORDER_TIME_DAY;
   if(ObjectGetInteger(0, "ActP_exp3_radio2", OBJPROP_STATE)==1) expir_type=ORDER_TIME_SPECIFIED;

   // 
   MqlTradeRequest req;
   MqlTradeResult res;
   ZeroMemory(req);
   req.action=TRADE_ACTION_PENDING;
   req.symbol=Symbol();
   req.volume=lots;
   req.price=NormalizeDouble(pr,Digits());
   req.stoplimit=NormalizeDouble(stoplim,Digits());
   req.sl=NormalizeDouble(SL, Digits());
   req.tp=NormalizeDouble(TP, Digits());
   req.type=typ;
   req.type_filling=filling;
   req.type_time=expir_type;
   req.expiration=expir;
   req.comment=comm;
   req.magic=mag;
   // 
   OrderSend(req,res);
   //   
   MessageBox(RetcodeDescription(res.retcode),"Message");
   //  
   return(res.retcode);
  }
//+------------------------------------------------------------------+
//|                                         |
//| ID -                          |
//+------------------------------------------------------------------+
bool ApplyScheme(int ID)
  {
   string fname="Active_Panel_scheme_custom_"+IntegerToString(ID)+".bin";
   //      
   if(!FileIsExist(fname)) fname="Active_Panel_scheme_"+IntegerToString(ID)+".bin";
   //   
   int handle=FileOpen(fname,FILE_READ|FILE_BIN);
   // 
   if(handle!=INVALID_HANDLE)
     {
      // 
      while(!FileIsEnding(handle))
        {
         string obj_name=FileReadString(handle,100);
         int _wnd=wnd;
         //     
         if(StringFind(obj_name,"line")>=0) _wnd=0;
         ENUM_OBJECT obj_type=ENUM_OBJECT (FileReadInteger(handle));
         // 
         ObjectCreate(0, obj_name, obj_type, _wnd, 0, 0);   
         //                                                       
         ObjectSetInteger(0,obj_name,OBJPROP_XDISTANCE,FileReadInteger(handle));
         ObjectSetInteger(0,obj_name,OBJPROP_YDISTANCE,FileReadInteger(handle));
         ObjectSetInteger(0,obj_name,OBJPROP_XSIZE,FileReadInteger(handle));
         ObjectSetInteger(0,obj_name,OBJPROP_YSIZE,FileReadInteger(handle));
         ObjectSetInteger(0,obj_name,OBJPROP_COLOR,FileReadInteger(handle));
         ObjectSetInteger(0,obj_name,OBJPROP_STYLE,FileReadInteger(handle));
         ObjectSetInteger(0,obj_name,OBJPROP_WIDTH,FileReadInteger(handle));
         ObjectSetInteger(0,obj_name,OBJPROP_BACK,FileReadInteger(handle));
         ObjectSetInteger(0,obj_name,OBJPROP_SELECTED,FileReadInteger(handle));
         ObjectSetInteger(0,obj_name,OBJPROP_SELECTABLE,FileReadInteger(handle));
         ObjectSetInteger(0,obj_name,OBJPROP_READONLY,FileReadInteger(handle));
         ObjectSetInteger(0,obj_name,OBJPROP_FONTSIZE,FileReadInteger(handle));
         ObjectSetInteger(0,obj_name,OBJPROP_STATE,FileReadInteger(handle));
         ObjectSetInteger(0,obj_name,OBJPROP_BGCOLOR,FileReadInteger(handle));

         ObjectSetString(0,obj_name,OBJPROP_TEXT,FileReadString(handle,100));
         ObjectSetString(0,obj_name,OBJPROP_FONT,FileReadString(handle,100));
         ObjectSetString(0,obj_name,OBJPROP_BMPFILE,0,FileReadString(handle,100));
         ObjectSetString(0,obj_name,OBJPROP_BMPFILE,1,FileReadString(handle,100));

         ObjectSetDouble(0,obj_name,OBJPROP_PRICE,FileReadDouble(handle));

         //   
         if(GlobalVariableCheck("ActP_buttons_color") && obj_type==OBJ_BUTTON)
            ObjectSetInteger(0,obj_name,OBJPROP_BGCOLOR,int(GlobalVariableGet("ActP_buttons_color")));
         if(GlobalVariableCheck("ActP_label_color") && obj_type==OBJ_LABEL)
            ObjectSetInteger(0,obj_name,OBJPROP_COLOR,int(GlobalVariableGet("ActP_label_color")));
         if(GlobalVariableCheck("ActP_text_color") && (obj_type==OBJ_EDIT || obj_type==OBJ_BUTTON))
            ObjectSetInteger(0,obj_name,OBJPROP_COLOR,int(GlobalVariableGet("ActP_text_color")));
         if(GlobalVariableCheck("ActP_font_size") && (obj_type==OBJ_EDIT || obj_type==OBJ_LABEL))
            ObjectSetInteger(0,obj_name,OBJPROP_FONTSIZE,int(GlobalVariableGet("ActP_font_size")));
         //     
         if(obj_name=="ActP_font_edit6" && GlobalVariableCheck("ActP_font_size"))
            ObjectSetString(0,obj_name,OBJPROP_TEXT,IntegerToString(int(GlobalVariableGet("ActP_font_size"))));
        }
      // 
      FileClose(handle);
      return(true);
     }
   return(false);
  }
//+------------------------------------------------------------------+
//|                                         |
//+------------------------------------------------------------------+
void create_interface()
  {
   //   
   if(Reset_Expert_Settings)
     {
     //
      GlobalVariableDel("ActP_buttons_color");
      GlobalVariableDel("ActP_label_color");
      GlobalVariableDel("ActP_text_color");
      GlobalVariableDel("ActP_font_size");
     }

   //   
   ApplyScheme(0);
   //   " "
   ApplyScheme(1);
   //   
   Objects_Selectable("ActP",false);
   // 
   ChartRedraw();
  }
//+------------------------------------------------------------------+
//|                                             |
//| name -                                                        |
//| text -                                                    |
//| X, Y, X_size, Y_size -                                  |
//+------------------------------------------------------------------+
bool create_button(string name,string text,int X,int Y,int X_size,int Y_size)
  {
   // 
   if(ObjectCreate(0,name,OBJ_BUTTON,wnd,0,0))
     {
      //   
      ObjectSetInteger(0,name,OBJPROP_XDISTANCE,X);
      ObjectSetInteger(0,name,OBJPROP_YDISTANCE,Y);
      ObjectSetInteger(0,name,OBJPROP_XSIZE,X_size);
      ObjectSetInteger(0,name,OBJPROP_YSIZE,Y_size);
      ObjectSetString(0,name,OBJPROP_FONT,"Arial");
      ObjectSetString(0,name,OBJPROP_TEXT,text);
      ObjectSetInteger(0,name,OBJPROP_FONTSIZE,10);
      ObjectSetInteger(0,name,OBJPROP_SELECTABLE,0);
      return(true);
     }
   return(false);
  }
//+------------------------------------------------------------------+
//|                                 |
//| IDstr - -                                     |
//+------------------------------------------------------------------+
void  ObjectsDeleteAll_my(string IDstr)
  {
   //  
   for(int i=ObjectsTotal(0);i>=0;i--)
     {
      string n=ObjectName(0,i);
      //     -  
      if(StringFind(n,IDstr)>=0) ObjectDelete(0,n);
     }
  }
//+------------------------------------------------------------------+
//|                           |
//+------------------------------------------------------------------+
void  Objects_Selectable(string IDstr,bool flag)
  {
   //  
   for(int i=ObjectsTotal(0);i>=0;i--)
     {
      string n=ObjectName(0,i);
      //   
      if(StringFind(n,IDstr)>=0)
        {
         //  
         if(!flag)
            if(StringFind(n,"line")>-1) continue; 
         //  ,  
         ObjectSetInteger(0,n,OBJPROP_SELECTABLE,flag); 
        }
     }
  }
//+------------------------------------------------------------------+
//|                                   |
//+------------------------------------------------------------------+
void get_prices()
  {
   MqlTick tick;
   //  
   if(SymbolInfoTick(Symbol(),tick))
     {
      // 
      Bid=tick.bid;
      Ask=tick.ask;
      time_current=tick.time;
     }
  }
//+------------------------------------------------------------------+
//|     ,               |
//+------------------------------------------------------------------+
void  DeleteScheme(string IDstr)
  {
   //  
   for(int i=ObjectsTotal(0);i>=0;i--)
     {
      string n=ObjectName(0,i);
      // ,  
      if(StringFind(n,IDstr)>=0 && StringFind(n,"main")<0) ObjectDelete(0,n); 
     }
  }
//+------------------------------------------------------------------+
//|     ,                           |
//|                     |
//+------------------------------------------------------------------+
void  DeleteScheme(string IDstr,bool fl)
  {
   //  
   for(int i=ObjectsTotal(0);i>=0;i--)
     {
      string n=ObjectName(0,i);
      //     ,  
      if(fl && n=="ActP_ord_button5") continue; 
      // ,  
      if(StringFind(n,IDstr)>=0 && StringFind(n,"main")<0) ObjectDelete(0,n);
     }
  }
//+------------------------------------------------------------------+
//|                                            |
//+------------------------------------------------------------------+
void  DeleteLists(string IDstr)
  {
   //  
   for(int i=ObjectsTotal(0);i>=0;i--)
     {
      string n=ObjectName(0,i);
      // 
      if(StringFind(n,IDstr)>=0 && StringFind(n,"main")<0) ObjectDelete(0,n);
     }
  }
//+------------------------------------------------------------------+
//|                               |
//| str -                                            |
//+------------------------------------------------------------------+
string str_del_zero(string str)
  {
  //  
   int len=StringLen(str)-1;
   int pos=len;
   // 
   for(int i=len;i>=0;i--)
     {
      //    
      char symb=char(StringGetCharacter(str,i));
      //  -  
      if(symb=='.') {pos--; break;}
      //  -   
      // 
      if(symb=='0') pos=i; 
      else break;
     }
   // ,   
   str=StringSubstr(str,0,pos);
   return(str);
  }
//+------------------------------------------------------------------+
//|                                       |
//+------------------------------------------------------------------+
void SaveScheme(int interfaceID)
  {
   //   
   int handle=FileOpen("Active_Panel_scheme_custom_"+IntegerToString(interfaceID)+".bin",FILE_WRITE|FILE_BIN);
   //  
   if(handle!=INVALID_HANDLE)
     {
      //    
      for(int i=0;i<ObjectsTotal(0);i++)
        {
         string name=ObjectName(0,i);
         //   
         if(StringFind(name,"ActP")<0) continue;
         //   
         if(StringFind(name,"main")>=0) continue; 
         //    
         FileWriteString(handle,name,100);
         FileWriteInteger(handle,int(ObjectGetInteger(0,name,OBJPROP_TYPE)));

         FileWriteInteger(handle,int(ObjectGetInteger(0,name,OBJPROP_XDISTANCE)));
         FileWriteInteger(handle,int(ObjectGetInteger(0,name,OBJPROP_YDISTANCE)));
         FileWriteInteger(handle,int(ObjectGetInteger(0,name,OBJPROP_XSIZE)));
         FileWriteInteger(handle,int(ObjectGetInteger(0,name,OBJPROP_YSIZE)));
         FileWriteInteger(handle,int(ObjectGetInteger(0,name,OBJPROP_COLOR)));
         FileWriteInteger(handle,int(ObjectGetInteger(0,name,OBJPROP_STYLE)));
         FileWriteInteger(handle,int(ObjectGetInteger(0,name,OBJPROP_WIDTH)));
         FileWriteInteger(handle,int(ObjectGetInteger(0,name,OBJPROP_BACK)));
         FileWriteInteger(handle,int(ObjectGetInteger(0,name,OBJPROP_SELECTED)));
         FileWriteInteger(handle,int(ObjectGetInteger(0,name,OBJPROP_SELECTABLE)));
         FileWriteInteger(handle,int(ObjectGetInteger(0,name,OBJPROP_READONLY)));
         FileWriteInteger(handle,int(ObjectGetInteger(0,name,OBJPROP_FONTSIZE)));
         FileWriteInteger(handle,int(ObjectGetInteger(0,name,OBJPROP_STATE)));
         FileWriteInteger(handle,int(ObjectGetInteger(0,name,OBJPROP_BGCOLOR)));

         FileWriteString(handle,ObjectGetString(0,name,OBJPROP_TEXT),100);
         FileWriteString(handle,ObjectGetString(0,name,OBJPROP_FONT),100);
         FileWriteString(handle,ObjectGetString(0,name,OBJPROP_BMPFILE,0),100);
         FileWriteString(handle,ObjectGetString(0,name,OBJPROP_BMPFILE,1),100);

         FileWriteDouble(handle,ObjectGetDouble(0,name,OBJPROP_PRICE));
        }
      //   
      FileClose(handle);
     }
  }
//+------------------------------------------------------------------+
color colors[132]=
  {
   Black,
   DarkGreen,
   DarkSlateGray,
   Olive,
   Green,
   Teal,
   Navy,
   Purple,
   Maroon,
   Indigo,
   MidnightBlue,
   DarkBlue,
   DarkOliveGreen,
   SaddleBrown,
   ForestGreen,
   OliveDrab,
   SeaGreen,
   DarkGoldenrod,
   DarkSlateBlue,
   Sienna,
   MediumBlue,
   Brown,
   DarkTurquoise,
   DimGray,
   LightSeaGreen,
   DarkViolet,
   FireBrick,
   MediumVioletRed,
   MediumSeaGreen,
   Chocolate,
   Crimson,
   SteelBlue,
   Goldenrod,
   MediumSpringGreen,
   LawnGreen,
   CadetBlue,
   DarkOrchid,
   YellowGreen,
   LimeGreen,
   OrangeRed,
   DarkOrange,
   Orange,
   Gold,
   Yellow,
   Chartreuse,
   Lime,
   SpringGreen,
   Aqua,
   DeepSkyBlue,
   Blue,
   Magenta,
   Red,
   Gray,
   SlateGray,
   Peru,
   BlueViolet,
   LightSlateGray,
   DeepPink,
   MediumTurquoise,
   DodgerBlue,
   Turquoise,
   RoyalBlue,
   SlateBlue,
   DarkKhaki,
   IndianRed,
   MediumOrchid,
   GreenYellow,
   MediumAquamarine,
   DarkSeaGreen,
   Tomato,
   RosyBrown,
   Orchid,
   MediumPurple,
   PaleVioletRed,
   Coral,
   CornflowerBlue,
   DarkGray,
   SandyBrown,
   MediumSlateBlue,
   Tan,
   DarkSalmon,
   BurlyWood,
   HotPink,
   Salmon,
   Violet,
   LightCoral,
   SkyBlue,
   LightSalmon,
   Plum,
   Khaki,
   LightGreen,
   Aquamarine,
   Silver,
   LightSkyBlue,
   LightSteelBlue,
   LightBlue,
   PaleGreen,
   Thistle,
   PowderBlue,
   PaleGoldenrod,
   PaleTurquoise,
   LightGray,
   Wheat,
   NavajoWhite,
   Moccasin,
   LightPink,
   Gainsboro,
   PeachPuff,
   Pink,
   Bisque,
   LightGoldenrod,
   BlanchedAlmond,
   LemonChiffon,
   Beige,
   AntiqueWhite,
   PapayaWhip,
   Cornsilk,
   LightYellow,
   LightCyan,
   Linen,
   Lavender,
   MistyRose,
   OldLace,
   WhiteSmoke,
   Seashell,
   Ivory,
   Honeydew,
   AliceBlue,
   LavenderBlush,
   MintCream,
   Snow,
   White
  };
//+------------------------------------------------------------------+
//|             |
//+------------------------------------------------------------------+
string RetcodeDescription(int retcode)
  {
   string str;
//---
   switch(retcode)
     {
      case TRADE_RETCODE_REQUOTE:
         str="Requote";
         break;
      case TRADE_RETCODE_REJECT:
         str="Request rejected";
         break;
      case TRADE_RETCODE_CANCEL:
         str="Request cancelled by trader";
         break;
      case TRADE_RETCODE_PLACED:
         str="Order placed";
         break;
      case TRADE_RETCODE_DONE:
         str="Request done";
         break;
      case TRADE_RETCODE_DONE_PARTIAL:
         str="Request done partially";
         break;
      case TRADE_RETCODE_ERROR:
         str="Common error";
         break;
      case TRADE_RETCODE_TIMEOUT:
         str="Request cancelled by timeout";
         break;
      case TRADE_RETCODE_INVALID:
         str="Invalid request";
         break;
      case TRADE_RETCODE_INVALID_VOLUME:
         str="Invalid volume in request";
         break;
      case TRADE_RETCODE_INVALID_PRICE:
         str="Invalid price in request";
         break;
      case TRADE_RETCODE_INVALID_STOPS:
         str="Invalid stop(s) request";
         break;
      case TRADE_RETCODE_TRADE_DISABLED:
         str="Trade is disabled";
         break;
      case TRADE_RETCODE_MARKET_CLOSED:
         str="Market is closed";
         break;
      case TRADE_RETCODE_NO_MONEY:
         str="Not enough money";
         break;
      case TRADE_RETCODE_PRICE_CHANGED:
         str="Price changed";
         break;
      case TRADE_RETCODE_PRICE_OFF:
         str="No quotes for query processing";
         break;
      case TRADE_RETCODE_INVALID_EXPIRATION:
         str="Invalid expiration time in request";
         break;
      case TRADE_RETCODE_ORDER_CHANGED:
         str="Order state changed";
         break;
      case TRADE_RETCODE_TOO_MANY_REQUESTS:
         str="Too frequent requests";
         break;
      case TRADE_RETCODE_NO_CHANGES:
         str="No changes in request";
         break;
      case TRADE_RETCODE_SERVER_DISABLES_AT:
         str="Autotrading disabled by server";
         break;         
      case TRADE_RETCODE_CLIENT_DISABLES_AT:
         str="Autotrading disabled by client terminal";
         break;         
      case TRADE_RETCODE_LOCKED:
         str="Request locked for processing";
         break;
      case TRADE_RETCODE_FROZEN:
         str="Order or position frozen";
         break;        
      case TRADE_RETCODE_INVALID_FILL:
         str="Invalid order filling type";
         break;
      case TRADE_RETCODE_CONNECTION:
         str="No connection with the trade server";
         break;              
      default:
         str="Unknown result";
     }
//---
   return(str);
  }
//+------------------------------------------------------------------+